﻿using Plane.Copters;
using Plane.Logging;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Plane.FormationCreator.Formation
{
    public partial class FlightTask
    {
        public async Task RunTurnTaskAsync()
        {
            await Task.WhenAll(
                SingleCopterInfos.Select(info => TurnTaskFlySingleCopterAsync(info))
            ).ConfigureAwait(false);
        }

        private async Task TurnTaskFlySingleCopterAsync(FlightTaskSingleCopterInfo info)
        {
            int copterIndex = SingleCopterInfos.IndexOf(info);
            // 当该飞机被标记时，跳过飞行任务
            if ((bool)_copterManager.CopterStatus[copterIndex])
                return;

            await info.Copter.SetMobileControlAsync(yaw: info.TargetHeading);
            while (!info.Copter.ArrivedHeading(info.TargetHeading))
            {
                if (_flightTaskManager.IsPaused == true)
                {
                    await info.Copter.HoverAsync();
                    return;
                }
                await Task.Delay(25).ConfigureAwait(false);
            }

            await info.Copter.HoverAsync();
        }
    }
}
