﻿using Plane.FormationCreator.Formation;
using Plane.Windows.Messages;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.CommandWpf;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace Plane.FormationCreator.ViewModels
{
    public class TaskBarViewModel : ViewModelBase
    {
        public TaskBarViewModel(FlightTaskManager flightTaskManager)
        {
            _flightTaskManager = flightTaskManager;
        }

        private FlightTaskManager _flightTaskManager;
        public FlightTaskManager FlightTaskManager { get { return _flightTaskManager; } }

        public ObservableCollection<FlightTask> Tasks { get { return _flightTaskManager.Tasks; } }

        private ICommand _AddTaskCommand;
        public ICommand AddTaskCommand
        {
            get
            {
                return _AddTaskCommand ?? (_AddTaskCommand = new RelayCommand(() =>
                {
                    _flightTaskManager.AddTask();
                }));
            }
        }

        private ICommand _ClearTasksCommand;
        public ICommand ClearTasksCommand
        {
            get
            {
                return _ClearTasksCommand ?? (_ClearTasksCommand = new RelayCommand(() =>
                {
                    _flightTaskManager.ClearTasks();
                }));
            }
        }

       private ICommand _NextTasksCommand;
        public ICommand NextTasksCommand
        {
            get
            {
                return _NextTasksCommand ?? (_NextTasksCommand = new RelayCommand(async () =>
                {
                   // await _flightTaskManager.RunAsync();
                    await _flightTaskManager.ForceNextTasks();
                      //  Message.Show("任务开始");
                     //   await _flightTaskManager.RunAsync();
                      //  Message.Show(_flightTaskManager.IsPaused == true ? "任务暂停" : "任务完成");
                 }));
            }
        }

        private ICommand _ResetTasksCommand;
        public ICommand ResetTasksCommand
        {
            get
            {
                return _ResetTasksCommand ?? (_ResetTasksCommand = new RelayCommand(() =>
                {
                    _flightTaskManager.ResetTasks();
                }));
            }
        }

        //private ICommand _CancelModifyingTaskCommand;
        //public ICommand CancelModifyingTaskCommand
        //{
        //    get
        //    {
        //        return _CancelModifyingTaskCommand ?? (_CancelModifyingTaskCommand = new RelayCommand(() =>
        //        {
        //            AppEx.Instance.CurrentMode = AppMode.PreparedForRunningTasks;
        //        }));
        //    }
        //}

        private ICommand _RunTasksCommand;
        public ICommand RunTasksCommand
        {
            get
            {
                return _RunTasksCommand ?? (_RunTasksCommand = new RelayCommand(async () =>
                {
                    //    string s = JsonConvert.SerializeObject(_flightTaskManager.Tasks, new JsonSerializerSettings
                    //    {
                    //        TypeNameHandling = TypeNameHandling.Objects
                    //    });
                    //    Alert.Show(s);
                    //    return;
                    await _flightTaskManager.RunTaskAsync();
                }));
            }
        }

        private ICommand _PauseTasksCommand;
        public ICommand PauseTasksCommand
        {
            get
            {
                return _PauseTasksCommand ?? (_PauseTasksCommand = new RelayCommand(() =>
                {
                    _flightTaskManager.Pause();
                }));
            }
        }
    }
}
